/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-mongodb-store-msgs-0.1.12-1precise-20150329-2029/srv/MongoInsertMsg.srv
 *
 */


#ifndef MONGODB_STORE_MSGS_MESSAGE_MONGOINSERTMSGREQUEST_H
#define MONGODB_STORE_MSGS_MESSAGE_MONGOINSERTMSGREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mongodb_store_msgs/SerialisedMessage.h>
#include <mongodb_store_msgs/StringPairList.h>

namespace mongodb_store_msgs
{
template <class ContainerAllocator>
struct MongoInsertMsgRequest_
{
  typedef MongoInsertMsgRequest_<ContainerAllocator> Type;

  MongoInsertMsgRequest_()
    : database()
    , collection()
    , message()
    , meta()  {
    }
  MongoInsertMsgRequest_(const ContainerAllocator& _alloc)
    : database(_alloc)
    , collection(_alloc)
    , message(_alloc)
    , meta(_alloc)  {
    }



   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _database_type;
  _database_type database;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _collection_type;
  _collection_type collection;

   typedef  ::mongodb_store_msgs::SerialisedMessage_<ContainerAllocator>  _message_type;
  _message_type message;

   typedef  ::mongodb_store_msgs::StringPairList_<ContainerAllocator>  _meta_type;
  _meta_type meta;




  typedef boost::shared_ptr< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct MongoInsertMsgRequest_

typedef ::mongodb_store_msgs::MongoInsertMsgRequest_<std::allocator<void> > MongoInsertMsgRequest;

typedef boost::shared_ptr< ::mongodb_store_msgs::MongoInsertMsgRequest > MongoInsertMsgRequestPtr;
typedef boost::shared_ptr< ::mongodb_store_msgs::MongoInsertMsgRequest const> MongoInsertMsgRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mongodb_store_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'mongodb_store_msgs': ['/tmp/buildd/ros-hydro-mongodb-store-msgs-0.1.12-1precise-20150329-2029/msg', '/tmp/buildd/ros-hydro-mongodb-store-msgs-0.1.12-1precise-20150329-2029/obj-x86_64-linux-gnu/devel/share/mongodb_store_msgs/msg'], 'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d071b179071167c692331b5356e30470";
  }

  static const char* value(const ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd071b179071167c6ULL;
  static const uint64_t static_value2 = 0x92331b5356e30470ULL;
};

template<class ContainerAllocator>
struct DataType< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mongodb_store_msgs/MongoInsertMsgRequest";
  }

  static const char* value(const ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "\n\
\n\
string database\n\
string collection\n\
SerialisedMessage message\n\
\n\
StringPairList meta\n\
\n\
================================================================================\n\
MSG: mongodb_store_msgs/SerialisedMessage\n\
# type to of the serialised message\n\
string type\n\
# the serialised message\n\
uint8[] msg\n\
================================================================================\n\
MSG: mongodb_store_msgs/StringPairList\n\
StringPair[] pairs\n\
\n\
================================================================================\n\
MSG: mongodb_store_msgs/StringPair\n\
string first\n\
string second\n\
";
  }

  static const char* value(const ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.database);
      stream.next(m.collection);
      stream.next(m.message);
      stream.next(m.meta);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct MongoInsertMsgRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mongodb_store_msgs::MongoInsertMsgRequest_<ContainerAllocator>& v)
  {
    s << indent << "database: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.database);
    s << indent << "collection: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.collection);
    s << indent << "message: ";
    s << std::endl;
    Printer< ::mongodb_store_msgs::SerialisedMessage_<ContainerAllocator> >::stream(s, indent + "  ", v.message);
    s << indent << "meta: ";
    s << std::endl;
    Printer< ::mongodb_store_msgs::StringPairList_<ContainerAllocator> >::stream(s, indent + "  ", v.meta);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MONGODB_STORE_MSGS_MESSAGE_MONGOINSERTMSGREQUEST_H
